// Copyright 2014 the V8 project authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Flags: --allow-natives-syntax --fold-constants

function test() {
  assertEquals("string", typeof "");
  assertEquals("number", typeof 1.1);
  assertEquals("number", typeof 1);
  assertEquals("boolean", typeof true);
  assertEquals("function", typeof function() {});
  assertEquals("object", typeof null);
  assertEquals("object", typeof {});
  assertEquals("object", typeof /regex/);

  assertTrue(V8IsSmi(1));
  assertFalse(V8IsSmi(1.1));
  assertFalse(V8IsSmi({}));

  assertTrue(V8IsRegExp(/regexp/));
  assertFalse(V8IsRegExp({}));

  assertTrue(V8IsArray([1]));
  assertFalse(V8IsArray(function() {}));

  assertTrue(V8IsFunction(function() {}));
  assertFalse(V8IsFunction(null));

  assertTrue(V8IsJSReceiver(new Date()));
  assertFalse(V8IsJSReceiver(1));

  assertTrue(V8IsMinusZero(-0.0));
  assertFalse(V8IsMinusZero(1));
  assertFalse(V8IsMinusZero(""));
}


test();
test();
V8OptimizeFunctionOnNextCall(test);
test();
